#ifndef __DataTemplate_h__
#define __DataTemplate_h__

#include "Data.h"
#include <iostream>
#include <string>
#include <string.h>

template<class T>
class DataTemplate : public Data {
public:
	DataTemplate(const std::string& type, const std::string& name, 
	             unsigned long len);
	~DataTemplate();
	unsigned long format_data(const uint8_t* buff, unsigned long len);
	
	T* actual_data;
};

// Separate implementation of template class from declaration

template<class T>
DataTemplate<T>::DataTemplate(const std::string& type, const std::string& name, 
             unsigned long len) : 
             Data(type, name, sizeof(T), len)
{
	std::cout << __PRETTY_FUNCTION__ << ": name=" << name << 
	             std::endl;
	actual_data = new T[len];
};

template<class T>
DataTemplate<T>::~DataTemplate()
{
	std::cout << __PRETTY_FUNCTION__ << ": name=" << get_name() << 
	        std::endl;
	delete[] actual_data;
};

template<class T>
unsigned long DataTemplate<T>::format_data(const uint8_t* buff, 
                                           unsigned long len)
{
	unsigned long required_len = get_tot_size(); 
	if (required_len > len) {
		std::cout << "Not enough bytes to read Data." << 
		             std::endl;
		return 0;
	}
	memcpy(actual_data, buff, required_len);
	return required_len;
};

#endif // __DataTemplate_h__
