#include "DataFactory.h"
#include <iostream>

using namespace std;

std::map<string, DataFactory::creator_type_t>* DataFactory::lookup_table = NULL;

DataFactory::DataFactory(const string& id, creator_type_t func)
{
	if (!lookup_table)
		lookup_table = new map<string, creator_type_t>();
	if (lookup_table->find(id) != lookup_table->end()) {
		cout << "Fatory Registration Error: Creator already registered"
		        " for ID=" << id << endl;
		return;
	}
	cout << "Fatory Registration Done: for ID=" << id << endl;
	(*lookup_table)[id] = func;
}

Data* DataFactory::create(const string& id, const string& n, unsigned long len)
{
	map<string, creator_type_t>::iterator elem = lookup_table->find(id);
	if (elem == lookup_table->end()) {
		cout << "Fatory Creation Error: Creator not registered"
		        " for ID=" << id << endl;
		return NULL;
	}
	return elem->second(n, len);
}
