#include "FormatHandler.h"
#include "Data.h"
#include "FakeXmlParser.h"

#include "DataFactory.h"
#include <iostream>

using namespace std;

FormatHandler::FormatHandler()
{
	// We create the data vector according to XML config
	vector<XmlDataElement> config = parse_xml_data();

	vector<XmlDataElement>::const_iterator it;
	for (it = config.begin(); it != config.end(); ++it) {
		Data *d = DataFactory::create(it->type, it->name, it->len);
		if (!d) {
			cout << "Unable to create data type = '" << it->type << 
			        "' ! Skipping" << endl;
			continue;
		}
		data_vector.push_back(d);
	}
}

FormatHandler::~FormatHandler()
{
	// We have to destroy the data vector properly
	vector<Data*>::iterator it;
	for (it = data_vector.begin(); it != data_vector.end(); ++it)
		delete *it;
}

void FormatHandler::format(uint8_t* rawdata, unsigned long len)
{
	vector<Data*>::iterator it;
	for (it = data_vector.begin(); it != data_vector.end(); ++it) {
		unsigned long used_bytes = (*it)->format_data(rawdata, len);
		len -= used_bytes;
		rawdata += used_bytes;
	}
}
